#ifndef DEVICEMANAGER_H
#define DEVICEMANAGER_H

#include "fly-device_global.h"
#include "device.h"

#include <QSharedPointer>

namespace Solid {
    class Device;
}

class FLYDEVICESHARED_EXPORT DeviceManager : public QObject
{
    Q_OBJECT
public:
    explicit DeviceManager(QObject *parent = nullptr);
    ~DeviceManager();

signals:
    void deviceAdded(QSharedPointer<Device> device);
    void deviceRemoved(const QString &udi);

public slots:
    void loadDevices();

private slots:
    void onDeviceAdded(const QString &udi);
    void onDeviceRemoved(const QString &udi);

private:
    void addDevice(Solid::Device &device);
};

#endif // DEVICEMANAGER_H
