#ifndef FLYDEVICE_H
#define FLYDEVICE_H

#include "device.h"

namespace FlyPhone {
    class FlyNotificationsModelDbusNotifier;
    class FlyNotificationDbusNotifier;
}

#include <QVariantMap>
#include <QSharedPointer>

class FLYDEVICESHARED_EXPORT FlyDevice : public QObject
{
    Q_OBJECT
public:
    explicit FlyDevice(QSharedPointer<Device> device,
                       FlyPhone::FlyNotificationsModelDbusNotifier *notifier,
                       QObject *parent = nullptr);
    ~FlyDevice();

private slots:
    void onDeviceMounted();
    void onDeviceUnmounted();
    void onDeviceMountedByUs();
    void onNewData(const QString &data);
    void onDeviceMountFailed(const QString &title, const QString &description);
    void onDeviceEjectFailed(const QString &title, const QString &description);

private:
    void open();
    void eject();
    void openMountDir();

    QSharedPointer<Device> m_device;
    FlyPhone::FlyNotificationsModelDbusNotifier *m_notifier;
    FlyPhone::FlyNotificationDbusNotifier *m_notification;
    QVariantMap m_dataMap;
};

#endif // FLYDEVICE_H
