#ifndef FLYDEVICEMANAGER_H
#define FLYDEVICEMANAGER_H

#include "flydevice.h"
#include "devicemanager.h"

#include <QSharedPointer>

class FLYDEVICESHARED_EXPORT FlyDeviceManager : public QObject
{
    Q_OBJECT
public:
    explicit FlyDeviceManager(QObject *parent = nullptr);
    ~FlyDeviceManager();

public slots:
    void start();

private slots:
    void onDeviceAdded(QSharedPointer<Device> device);
    void onDeviceRemoved(const QString &uid);

private:
    DeviceManager m_deviceManager;
    FlyPhone::FlyNotificationsModelDbusNotifier *m_notifier;
    QHash<QString, QSharedPointer<FlyDevice>> m_devices;
};
#endif // FLYDEVICEMANAGER_H
